Subject: bug#16222: Installing ELPA packages complains about :keywords in define-package

From: Ted Zlatanov <[email-masked]>
Date: Mon, 23 Dec 2013 17:57:52 -0500

On Mon, 23 Dec 2013 16:13:32 +0100 Juanma Barranquero <[email-masked]> wrote: 

JB> On Mon, Dec 23, 2013 at 4:02 PM, Ted Zlatanov <[email-masked]> wrote:
>> Can you provide a full bug description, Emacs version, etc.?  I can't
>> find it here (I know there's an emacs-devel discussion but the bug
>> report is incomplete as is).

JB> With an Emacs from trunk, of a few days ago, I just did M-x
JB> list-packages, then U (packages to update where debbugs and
JB> rainbow-mode), then x, and voilà.

JB> Aren't you able to reproduce it?

I can reproduce it but don't see why you couldn't make a proper bug
report with a version (for the record, mine is 24.3.50.1, compiled today).

Stefan: I think the problem is `package--alist-to-plist'.  The generated
PACKAGE-pkg.el has, for example:

(define-package "ack" "1.3" "Interface to ack-like source code search tools" 'nil :keywords ("tools" "processes" "convenience") :url "https://github.com/leoliu/ack-el")

(define-package "nlinum" "1.1" "Show line numbers in the margin" 'nil :url "http://elpa.gnu.org/packages/nlinum.html" :keywords ("convenience"))

If I quote the keywords, e.g.

  :keywords '("convenience")

then the function call works but I don't really understand the creative
mix of `defstruct' and the `define-package' funcall that errors out, so
I couldn't write the fix and test it.  I hope you or someone else has a
chance to do it... I may try it again tomorrow if no one else does.

Ted